<template>
  <div class="app-container">
    <el-card class="box-card app-container">
      <el-row slot="header">
        <el-col :span="20">
          <h3>{{ title }}</h3>
        </el-col>
        <el-col :span="4">
          <el-button type="primary" class="fr" @click="submit">
            Guardar
          </el-button>
        </el-col>
      </el-row>
      <el-form class="form" ref="fields" :rules="rules" :model="fields" label-position="top">
        <el-form-item prop="$nonFieldError" :error="nonFieldError">
        </el-form-item>
        <el-form-item label="Nombre Completo" prop="name" :error="errors.name">
          <el-input v-model="fields.name" />
        </el-form-item>
        <el-form-item label="E-Mail" prop="email" :error="errors.email">
          <el-input v-model="fields.email" />
        </el-form-item>
      </el-form>
    </el-card>
  </div>
</template>

<script>
  import api from '@/feathers'
  import errors from '@feathersjs/errors'
  import BaseForm from '@/common/base-form.mixin'
  import { ValidationError } from '@/exceptions'

  export default {
    name: 'sales-man-form',
    mixins: [BaseForm],
    props: {
      id: {type: String, required: false}
    },
    computed: {
      title() {
        return `Actualizar ${this.fields.name}`
      }
    },
    data() {
      const rules = {
        name: [
          { required: true, message: 'Debe ingresar un nombre', trigger: 'blur' },
        ],
        email: [
          { type: 'email', message: 'Debe ingresar un e-mail válido (usuario@provedor.com', trigger: 'blur' },
          { required: true, message: 'Debe ingresar una dirección de e-mail obligatoriamente', trigger: 'blur' }
        ],
      }
      const {fields, errors} = this.buildForm(rules)

      return {
        rules,
        errors,
        fields
      }
    },
    async created() {
      this.service = api.service('salesmen')

      if ( this.id ) {
        this.fields = await this.service.get(this.id)
        this.action = 'update'
      } else {
        this.action = 'create'
        this.title = 'Nuevo vendedor'
      }
    },
    methods: {
      update() {
        return this
          .service
          .update(this.id, this.fields)
          .then(updatedSalesman => {
            this.$message({
              type: 'success',
              message: 'Datos guardados correctamente'
            })
          })
      },
      create() {
        return this
          .service
          .create(this.fields)
          .then(createdSalesman => {
            this.$message({
              type: 'success',
              message: 'Datos guardados correctamente'
            })
            this.clear()
          })
      },
      submit() {
        return this
          .validate()
          .then(() => this[this.action]())
          .caught(ValidationError, error => {
            this.$message({
              type: 'warning',
              message: 'Falló la validación, por favor verifique los mensajes de error.'
            })
          })
          .caught(errors.BadRequest, (errorResponse) => {
            this.$message({
              type: 'warning',
              message: 'Error al confirmar los datos'
            })
            this.populateBackendErrors(
              errorResponse.errors,
              (fieldName, fieldContent) => fieldContent.message
            )
          })
          .caught(errors.Conflict, (errorResponse) => {
            this.populateBackendErrors(
              errorResponse.errors,
              (conflictingField, conflictingValue) => `Ya existe un registro con ${conflictingField} "${conflictingValue}"`
            )
          })
      }
    }
  }
</script>

<style lang="scss">
  .el-card {
    &__header {
      margin: 0;
      paddiong: 10px 20px 4px 20px;
      h3 {
        margin: 0;
        padding: 10px 0px;
      }
    }
  }
</style>
